JSEPackage("ViaMichelin.Api.Map.ComplexLayer");

JSEImportApi("ViaMichelin.Api.Map.Layer");
JSEImportApi("ViaMichelin.Api.Model.GeoCoordinates");

ViaMichelin.Api.Map.ComplexLayer = function() {
	this.extend(ViaMichelin.Api.Map.Layer);
	this.prepare();	
	this.layers = new Array();
	this.unplugWire(new JSEWire("HTMLEvent_mouseclick",this.cancelBubbling,this));
	this.unplugWire(new JSEWire("HTMLEvent_mousedown",this.cancelBubbling,this));
	this.unplugWire(new JSEWire("HTMLEvent_mousemove",this.cancelBubbling,this));
	this.unplugWire(new JSEWire("HTMLEvent_mouseup",this.cancelBubbling,this));
};

ViaMichelin.Api.Map.ComplexLayer.prototype = {
	needClipping : true,
	layers : null,
	getNumberOfLayers : function(){
		return this.layers.length;
	},
	getGeoBoundaries : function(){
		var i = 0;
		var x0, y0, x1, y1;
		while (i < this.layers.length)
		{
			//getGeoBoundaries returns (upperLeftCorner, lowerRightCorner)
			if (i == 0) 
			{
				x0 =  parseFloat(this.layers[i].getGeoBoundaries()[0].lon);
				y0 =  parseFloat(this.layers[i].getGeoBoundaries()[1].lat);
				x1 =  parseFloat(this.layers[i].getGeoBoundaries()[1].lon);
				y1 =  parseFloat(this.layers[i].getGeoBoundaries()[0].lat);			
			}
			else {
				if (parseFloat(this.layers[i].getGeoBoundaries()[0].lon) < x0) x0 = parseFloat(this.layers[i].getGeoBoundaries()[0].lon);//min lon
				if (parseFloat(this.layers[i].getGeoBoundaries()[1].lat) < y0) y0 = parseFloat(this.layers[i].getGeoBoundaries()[1].lat);//min lat
				if (parseFloat(this.layers[i].getGeoBoundaries()[1].lon) > x1) x1 = parseFloat(this.layers[i].getGeoBoundaries()[1].lon);//max lon
				if (parseFloat(this.layers[i].getGeoBoundaries()[0].lat) > y1) y1 = parseFloat(this.layers[i].getGeoBoundaries()[0].lat);//max lat
			}	
			i++;
		}
		//upperLeftCorner, lowerRightCorner
		// TODO : Rechercher l'utilité des 2 variables dans le B2C avant de les supprimer.
		//this.upperLeftCorner = new ViaMichelin.Api.Model.GeoCoordinates(x0,y1);
		//this.lowerRightCorner= new ViaMichelin.Api.Model.GeoCoordinates(x1,y0);
		//return new Array(this.upperLeftCorner,this.lowerRightCorner);
		return new Array(new ViaMichelin.Api.Model.GeoCoordinates(x0,y1),new ViaMichelin.Api.Model.GeoCoordinates(x1,y0));
	},
	addLayer : function(layer){
		this.HTMLElement.appendChild(layer.HTMLElement);
		layer.mapObject = this.mapObject;
		this.layers.push(layer);
	},
	/**
	 * Supprime un layer en particulier
	 * @param {ViaMichelin.Api.Map.Layer} layer
	 * @return {void}
	 */
	removeLayer : function(layer){
		for (var i=0; i < this.layers.length; i++) {
			if (this.layers[i] == layer) {
				try {
					this.layers[i].isolate();
					this.HTMLElement.removeChild(this.layers[i].HTMLElement);
					this.layers[i].clearDOM();
				} catch (ex) {}
				this.layers[i].release();
				
				this.layers.splice(i, 1);
				break;
			}
		}
	},
	/**
	 * Supprime tous les layers
	 */
	removeLayers : function(){
		for (var i=0; i < this.layers.length; i++)
		{
			try {
				this.layers[i].isolate();
				this.HTMLElement.removeChild(this.layers[i].HTMLElement);
				this.layers[i].clearDOM();
			} catch (ex) {}
			this.layers[i].release();
		}
		this.layers = new Array();
	},
	convertToPoints : function(obj,func){
		this.HTMLElement.style.left = 0 + 'px';
		this.HTMLElement.style.top = 0 + 'px';
		for (var i=0; i < this.layers.length; i++) {
			this.layers[i].convertToPoints(obj,func);
		}
	}, 
	release : function() {
		for (var i=0; i < this.layers.length; i++) {
			this.layers[i].isolate();
			this.layers[i].release();
		}
		this.clearDOM();
	},
	toString : function() {
		return "[ViaMichelin.Api.Map.ComplexLayer]";
	}
};