JSEPackage("ViaMichelin.Api.Model.AbstractObject");

/**
 * Cette classe représente un objet sur lequel va potentiellement porter les commentaires, 
 * avis, photos, etc... Elle sera héritée par des objets tels que Destination, Folder, MPMPoi, etc...
 * 
 * @class ViaMichelin.Api.Model.AbstractObject
 */
ViaMichelin.Api.Model.AbstractObject = function() {
	
};

ViaMichelin.Api.Model.AbstractObject.prototype = {
	
	/**
	 * Permet de définir les différentes propriétés de l'objet
	 * 
	 * @param {Object} object
	 */
	update : function (paramObj) {
		for (var item in paramObj) {
			this[item] = paramObj[item];
		}
	},
	
	/**
	 * A surcharger
	 */
	getId : function () {
		return null;
	},
	
	/**
	 * A surcharger
	 */
	getObjectType : function () {
		return null;
	},
	
	/**
	 * A surcharger
	 */
	getObjectSubType : function () {
		return null;
	},
	
	
	// Méthodes permettant de tester le type de poi
	// ces méthodes sont définies ici afin que tous les types d'objets en hérite
	// Elles retournent toutes "false", à chaque objet de les surcharger si nécessaire
	// --------------------------------------------
	
	isPoiRestaurant : function() {
		return false;
	},
	
	isPoiHotel : function() {
		return false;
	},
	
	isPoiTourism : function() {
		return false;
	},
	
	isPoiLeisure : function() {
		return false;
	},
	
	isPoiTravelBook : function() {
		return false;
	},
	
	isPoiMagazine : function() {
		return false;
	},
	
	
	/**
	 * A surcharger
	 */
	toString : function () {
		return "[ViaMichelin.Api.Model.AbstractObject]";
	}
	
}