JSEPackage("ViaMichelin.Api.Model.Itinerary.ItineraryTrace");

/**
 * @class {ViaMichelin.Api.Model.Itinerary.ItineraryTrace}
 */
ViaMichelin.Api.Model.Itinerary.ItineraryTrace = function(bin64){
	this.bin64 = bin64;
	this.bin64Length = this.bin64.length;
};

ViaMichelin.Api.Model.Itinerary.ItineraryTrace.prototype = {
	bin64 : null,
	cursor : 0,
	getCoordsFromStringDirect : function(){
		//alert("Starting...")
		//var timer = (new Date()).getTime();
		
		var coordsLon = new Array();
		var coordsLat = new Array();
        var lat = this.decodeLatLon(this.bin64);
        var lon = this.decodeLatLon(this.bin64);
  		var precLon = lon;
  		var precLat = lat;
  		
        coordsLon[coordsLon.length] = precLon;
       	coordsLat[coordsLat.length]= precLat;
        
        var currLon, currLat;
        while (this.cursor < this.bin64Length) {
        	lat = this.decodeLatLon(this.bin64);
			lon = this.decodeLatLon(this.bin64);
			
			currLon = lon + precLon;
			currLat = lat + precLat;
			
			coordsLon[coordsLon.length] = currLon;
       		coordsLat[coordsLat.length]= currLat;
			
			precLon = currLon;
			precLat = currLat;
			
        }
		
		//alert((new Date()).getTime() - timer)	
		return [coordsLon, coordsLat];
	},
 	decodeLatLon : function(){
		 var val = 0;
		 
		 
		 if (this.cursor < this.bin64Length) {
		    var _a,_b,_c,_d,_e,_f;
		    _a = _b = _c = _d = _e = _f = 0;
		
		    var currByte = this.bin64.charCodeAt(this.cursor)-63;
		    this.cursor = this.cursor + 1;
		    _a = (currByte  & 0x00000001F);

		    
		    
		    if (((currByte & 0x20) == 0x20) && (this.cursor < this.bin64Length)) {
		    	currByte = this.bin64.charCodeAt(this.cursor)-63;
		      	this.cursor = this.cursor + 1;
		       	_b = (currByte  & 0x00000001F);
		    }
		    if (((currByte & 0x20) == 0x20) && (this.cursor < this.bin64Length)) {
		    	currByte = this.bin64.charCodeAt(this.cursor)-63;
		      	this.cursor = this.cursor + 1;
		       	_c = (currByte  & 0x00000001F);
		    }
		    if (((currByte & 0x20) == 0x20) && (this.cursor < this.bin64Length)) {
		    	currByte = this.bin64.charCodeAt(this.cursor)-63;
		      	this.cursor = this.cursor + 1;
		       	_d = (currByte  & 0x00000001F);
		    }
		    if (((currByte & 0x20) == 0x20) && (this.cursor < this.bin64Length)) {
		    	currByte = this.bin64.charCodeAt(this.cursor)-63;
		      	this.cursor = this.cursor + 1;
		       	_e = (currByte  & 0x00000001F);
		    }
		    if (((currByte & 0x20) == 0x20) && (this.cursor < this.bin64Length)) {
		    	currByte = this.bin64.charCodeAt(this.cursor)-63;
		      	this.cursor = this.cursor + 1;
		       	_f = (currByte  & 0x00000001F);
		    }
		    
		    val = val << 5;
		    val |= _f; 
		    val = val << 5;
		    val |= _e; 
		    val = val << 5;
		    val |= _d; 
		    val = val << 5;
		    val |= _c; 
		    val = val << 5;
		    val |= _b;
		    val = val << 5;
		    val |= _a;  
		    
		    if ( (val & 0x01) == 0x01) {
		       // le nombre codé est negatif :
		       val = ~(val>>1);
		    } else {
		       val = val>>1;
		    }
		 }		 
		 return val/100000;
 	},
 	toString : function(){
 		return "[ViaMichelin.Api.Model.Itinerary.ItineraryTrace]";
 	}
};