JSEPackage("ViaMichelin.Api.Model.Itinerary.RoadSheetV1");

JSEImportApi("ViaMichelin.Api.Model.Itinerary.ItineraryStep");
JSEImportApi("ViaMichelin.Api.Model.GeoCoordinates");
JSEImportApi("ViaMichelin.Api.Map.ComplexLayer");
JSEImportApi("ViaMichelin.Api.Util.Poi");
JSEImportApi("ViaMichelin.Api.Util.Other");

/**
 * @class ViaMichelin.Api.Model.Itinerary.RoadSheetV1
 * @constructor
 */
ViaMichelin.Api.Model.Itinerary.RoadSheetV1 = function(labels, imgSrc, unit, steps) {
	_VM_ROADSHEETPOIS = null;
	this.tollVehicule = "auto";
	this.labels = labels;
	this.imgSrc = imgSrc;
	this.imgSrc2 = ViaMichelin.Api.Constants.System.ApiImgPath + "all/iti/";
	this.unit = unit;
	/* On ajoute un espace insécable à l'unité de distance */
	//if(this.unit!=null && !(this.unit.indexOf("&nbsp;")>-1)){
	//	this.unit = "&nbsp;" + this.unit;
	//}
	
	this.lang = "";
	this.zone = "";
	
	this.alertes = new Object();
	this.alertes.nbAlertesSignalisations = 0;
	this.alertes.liste = new Array();
	
	if($isDefined(steps)) this.steps = this._transform(steps); //new Array();
};

ViaMichelin.Api.Model.Itinerary.RoadSheetV1.prototype = {
	// [ViaMichelin.Api.Model.Itinerary.ItineraryStep]
	steps : null,
	alertes : null,
	tollVehicule : null,
	labels : null,
	imgSrc : null,
	imgSrc2 : null,
	unit : null,
	zone : null,
	lang : null,
	_VMRoadsheetsIndex : null,

	addTo : function (target) {
		// Prepare DOM
		var elt = document.createElement("div");
		elt.id="VMroadsheet";
		target.appendChild(elt);
		// Add html code
		elt.innerHTML = this._getFeuilleDeRouteHTML();
		this._resizeBackGround(target);
		return target;
	},
	_resizeBackGround : function(element){
		var elementImages = element.getElementsByTagName("img"),
			len = elementImages.length;
		for (var i = 0; i<len; i++){
			var elementImage = elementImages[i];
			if (elementImage.className == "fdr_bgImg"){
				//Calcul de la taille de l element parent
				if(elementImage.nextSibling.nodeType == 1) elementImage.style.height = elementImage.nextSibling.offsetHeight+"px";
				else elementImage.style.height = elementImage.nextSibling.nextSibling.offsetHeight+"px";
			}
		} 
	},
	
	_getFeuilleDeRouteHTML : function(withMap) {
		var strHTML = '<div id="VMRoadSheetNew" class="VMRoadSheetNew VMRoadSheetV1">';
		var steps = this.steps;
		
		for (var i=0; i < steps.length; i++)
		{
			//Definition parité
			var isEtapeImpair = (i%2 == 0 || i == 0);
			
			strHTML += '<div'+(isEtapeImpair ? ' class="fdr_stepBlock fdr_bg"' : ' class="fdr_stepBlock"')+'>'
			+ (isEtapeImpair ? '<img class="fdr_bgImg" src="' + ViaMichelin.Api.Constants.System.ApiImgPath + 'all/iti/fdrBg.png" alt="" />' : '')
			+ '<table cellpadding="0" cellspacing="0">' 
			+ '<tr>';
			if (withMap){
				strHTML += ((isNaN(steps[i].number)||steps[i].number=="")	? "<td class='fdr_stepNumber' " + (((steps[i].details)&&(steps[i].details.length > 0)) ? "rowspan='"+(steps[i].details.length+1)+"'" : "" ) + ">"+steps[i].number+"</td>"
						: "<td class='fdr_stepNumber' " + (((steps[i].details)&&(steps[i].details.length > 0)) ? "rowspan='"+(steps[i].details.length+1)+"'" : "" ) + "><img class='printPastille' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath +"all/data/itisteps/e"+steps[i].number+".png'  alt='' />" + ViaMichelin.Api.Util.Poi.drawMiniPastilleBleue(steps[i].number) + "</td>");
			}else{
				if (isNaN(steps[i].number)||steps[i].number==""){
					
					strHTML += "<td class='fdr_stepNumber' ";
					if ((steps[i].details)&&(steps[i].details.length > 0)){
						strHTML +="rowspan='"+(steps[i].details.length+1)+"'";
					}
					var imgTxt = steps[i].number;
					if (imgTxt.indexOf("src=\'\'")!=-1){
						imgTxt = "";
					} 
					else{
						if (steps[i].type == "C" && imgTxt.indexOf("Flag")==-1){
							imgTxt = imgTxt.replaceAll("<img", "<img class='fdr_poi'");
						}
					}
					strHTML +=">"+imgTxt+"</td>";
				}
				else{
					strHTML += "<td class='fdr_stepNumber' " + (((steps[i].details)&&(steps[i].details.length > 0)) ? "rowspan='"+(steps[i].details.length+1)+"'" : "" ) + ">" + ViaMichelin.Api.Util.Poi.drawMiniPastilleBleue(steps[i].number) + "</td>";
				}
			}
			strHTML += '<td class="fdr_stepWays" ' + (((steps[i].details)&&(steps[i].details.length > 0)) ? "rowspan='"+(steps[i].details.length+1)+"'" : "" ) + ">" + steps[i].panels + '<span>&nbsp;</span></td>'
			+ '<td class="fdr_stepDetails">'+ steps[i].description + ((withMap) ? this._getMapBlock(steps[i].mapURL) : "") + '</td>'
			+ '<td class="fdr_lightGrey">'+((steps[i].distPleasant)?"<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/tourism.png' alt='' />":"")+steps[i].partialDistance+"</td>"
			+ '<td></td>'
			+ '<td></td>'
			+ '</tr>'
			+ (((steps[i].details)&&(steps[i].details.length > 0)) ? this._getDetailHTML(steps[i].details) : "")
			+ '<tr class="fdr_totalDistance">'
			+ '<td></td>'
			+ '<td></td>'
			+ '<td></td>'
			+ '<td></td>'
			+ '<td>' + steps[i].totalDistance + '</td>'
			+ '<td>' + steps[i].totalTime + '</td>'
			+ '</tr>'
			+ '</table>'
			+ '</div>';
		}
		strHTML += '</div>';
		return strHTML;
	},
	/**
	 * Récupère le layer avec les pastilles ainsi que les étapes dessus
	 * @param {Boolean} hideCorridor
	 * @return {ViaMichelin.Api.Map.ComplexLayer}
	 */
	getLayer : function(hideCorridor) {
		var cply = new ViaMichelin.Api.Map.ComplexLayer();		
		for (var i = 0; i < this.steps.length; i++) {
			if (this.steps[i].type != "M") {
				var step = this.steps[i];
				var html = typeof step.number == 'number' ? ViaMichelin.Api.Util.Poi.drawMiniPastilleBleue(step.number) : step.number;
				var vmly = typeof step.number == 'string' ?
					new ViaMichelin.Api.Map.Layer(step.coords, html, -1, -12):
					new ViaMichelin.Api.Map.Layer(step.coords, html, -5, -5);

				vmly.setExpandLayer(step.description + "<br/><img src='" + step.mapURL+"' style='width:250px;height:200px;' alt=''/>");
				
				vmly.contextMenuTemplate = "/htm/obf/iti/roadsheetContextV10.2.0.htm";
				
				if (typeof(step.number) == 'string') {
					if (typeof(step.stepIndex) != "undefined") {
						vmly.stepIndex = step.stepIndex;
						vmly.contextMenuTemplate = "/htm/obf/iti/roadsheetStepContextV10.2.0.htm";	
					}
				} 
				
				cply.addLayer(vmly);
				step.layer = vmly;
				if (!hideCorridor){
					// On affiche es POI corridor
					for (var j = 0; j < step.details.length; j++) {
						var sousStep = step.details[j];
						if (sousStep.bloc == "CORRPOI") {
							var vmly = new ViaMichelin.Api.Map.Layer(sousStep.coords, sousStep.number, -15, -8);
							vmly.HTMLElement.style.cursor = "pointer";
							vmly.poi = sousStep.poi;
							
							// On cast le poi en objet poi
							ToJSEObject(vmly.poi);
							vmly.poi = vmly.poi.cast(ViaMichelin.Api.Model.Poi);
							
							vmly.expando = this;
							vmly.plugWire(new JSEWire("HTMLEvent_mousedown",this._createExpand,vmly));
							vmly.HTMLElement.alt = sousStep.name;
							vmly.HTMLElement.title = sousStep.name;
							cply.addLayer(vmly);
						}
					}
				}
			}
		}		
		return cply;
	},
	/**
	 * Retourne le calque des evenements
	 * @return {ViaMichelin.Api.Map.ComplexLayer}
	 */
	getWarningsLayer : function () {
		var cply = new ViaMichelin.Api.Map.ComplexLayer();
		cply.expando = this;
		
		var roadsheet = this;
		var lenSteps = this.steps.length;
		for (var i = 0; i < lenSteps; i++) {
			var step = roadsheet.steps[i];
			for (var j = 0; j < step.details.length; j++) {				
				var sousStep = step.details[j];
				if ((sousStep.type == "M")					
					|| (sousStep.type == "c")					
					|| (sousStep.type == "vir")
					|| (sousStep.type == "lim")
					|| (sousStep.type == "dec")
					|| (sousStep.type == "S")						
					)
				{ 
					if (sousStep.coords && sousStep.coords.lon && (sousStep.coords.lon != 0) && sousStep.coords.lat && (sousStep.coords.lat != 0) && sousStep.picto && (sousStep.picto != "")) {
						var html = sousStep.picto;
						var vmly = new ViaMichelin.Api.Map.Layer(sousStep.coords, html, -1, -12);						
						vmly.HTMLElement.style.cursor = "pointer";	
						vmly.sousStep = sousStep;
						//vmly.plugWire(new JSEWire("HTMLEvent_mousedown",this._createExpandWarningElement,vmly));	
						var expandLayer = '<div class="sPODBubble">' + vmly.sousStep.description + '</div>';
						vmly.setExpandLayer(expandLayer);
						cply.addLayer(vmly);
					}
				}
			}
		}
		cply.isItiWarnings = true;
		return cply;
	},	
	release : function() {
		if (this._VMRoadsheetsIndex != null) window._VMRoadsheets[this._VMRoadsheetsIndex] = null;
	},
	/**
	 * Transforme le json en objet Roadsheet
	 * @param {Array} roadSheet
	 * @param {String} str
	 */
	_transform : function(roadSheet, str){
		var clonedRS = new Array();
		for (var i=0; i < roadSheet.length; i++)
		{
			clonedRS[i] = new Array();
			for (var j=0; j < roadSheet[i].length; j++)
			{
				clonedRS[i].push(roadSheet[i][j]);
			}
		}
		roadSheet = clonedRS;
		
		//Stockage de l'objet roadsheet au niveau global pour gestion clics sur itis via/depuis/vers dans datasheet CORRPOI
		if (typeof(window._VMRoadsheets) == "undefined") 
		{
			window._VMRoadsheets = new Array();
		}
		if (this._VMRoadsheetsIndex == null) {
			window._VMRoadsheets.push(this);
			this._VMRoadsheetsIndex = window._VMRoadsheets.length - 1;
		}
		
		var result = new Array();
		var firstWay = true;
		var lastWay = "";
		var etapesIds = new Array("A","B","C");
		var etapesIdsIndex = 0;
		var stepNumber = 1;
		var oVMStep;
		
		for (var i=0; i < roadSheet.length; i++) {
			var strSortie = "";
			if (roadSheet[i] != null) {
				oVMStep = new ViaMichelin.Api.Model.Itinerary.ItineraryStep();
				roadSheet[i].bloc = roadSheet[i][0];
				roadSheet[i].splice(0,1);
				oVMStep.type = roadSheet[i].bloc;
				if (roadSheet[i].bloc == "V")
				{
					var obj = ["coords","tDist","tTime","lDist","lTime","inAngle","inCity","inProxy","inDirLib","type","voies","pays","inRondPoint","nameRondPoint","inStyle","isWithDirection","distPleasant","timePleasant","url","detail"];
					this._configureObject(roadSheet[i], obj);
					roadSheet[i].picto = "";
					roadSheet[i].text = "";
					oVMStep.number = stepNumber++;
					oVMStep.panels = this._computePanneaux(roadSheet[i]);
					
					oVMStep.description = this._wayToHTML(roadSheet[i],firstWay,lastWay);
					oVMStep.shortDescription = this._wayToHTML(roadSheet[i],firstWay,lastWay,true);

					if (roadSheet[i].picto.indexOf("<br>" != -1)) roadSheet[i].picto = roadSheet[i].picto.replaceAll("<br>","");
					if (roadSheet[i].picto.indexOf("<br/>" != -1)) roadSheet[i].picto = roadSheet[i].picto.replaceAll("<br/>","");
					oVMStep.picto = roadSheet[i].picto;
					oVMStep.partialDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].lDist,this.unit);
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
					if (roadSheet[i].distPleasant) {
						oVMStep.distPleasant = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].distPleasant,this.unit);
					}
					firstWay = false;
					lastWay = this._getWayList(roadSheet[i][10]);
					oVMStep.mapURL = roadSheet[i].url;
				}
				if (roadSheet[i].bloc == "C")
				{
					var obj = ["coords","tDist","tTime","lDist","lTime","city","cityLine","addressLine","isNeighbor","type","reflex","landing","url","detail"];
					this._configureObject(roadSheet[i], obj);

					var isStep = true;
					var blocStr = "";
					var number = stepNumber;
					var isShort = false;
					if (roadSheet[i].landing === "") {
						if (roadSheet[i].type == 0) {
							if(navigator.isIE6)
								number = "<img src=\""+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/s.gif\" width=\"16\" height=\"15\" style=\"filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='"+ this.imgSrc2 + "greenFlag.png',sizingMethod='scale')+\"/>";
							else if(navigator.userAgent.indexOf('Firefox/2') != -1)
								number = '<img src="'+ ViaMichelin.Api.Constants.System.ApiImgPath + 'all/data/itifdr/drapeau_depart.gif" alt="" />';
							else
								number = "<img src='" + this.imgSrc2 + "greenFlag.png' width='16' height='15' alt='' />";
							blocStr += "<b>"+this.labels["lab_depart"];
							if (roadSheet[i].addressLine == "") blocStr += roadSheet[i].city + this.labels["lab_centre"];
							else blocStr += roadSheet[i].city + ", " + roadSheet[i].addressLine;
						}
						else if (roadSheet[i].type == 1) {
							if(navigator.isIE6)
								number = "<img src=\""+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/s.gif\" width=\"16\" height=\"15\" style=\"filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='"+ this.imgSrc2 + "redFlag.png',sizingMethod='scale')+\"/>";
							else if(navigator.userAgent.indexOf('Firefox/2') != -1)
								number = '<img src="'+ ViaMichelin.Api.Constants.System.ApiImgPath + 'all/data/itifdr/drapeau_arrivee.gif" alt="" />';
							else
								number = "<img src='" + this.imgSrc2 + "redFlag.png' width='16' height='15' alt='' />";
							blocStr += "<b>"+this.labels["lab_arrivee"];
							if (roadSheet[i].addressLine == "") blocStr += roadSheet[i].city + this.labels["lab_centre"];
							else blocStr += roadSheet[i].city + ", " + roadSheet[i].addressLine;
						}
						else if (roadSheet[i].type == 2) {
							if(navigator.isIE6)
								number = "<img src=\""+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/s.gif\" width=\"16\" height=\"15\" style=\"filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='"+ this.imgSrc2 + "blueFlag.png',sizingMethod='scale')+\"/>";
							else if(navigator.userAgent.indexOf('Firefox/2') != -1)
								number = '<img src="'+ ViaMichelin.Api.Constants.System.ApiImgPath + 'all/data/itifdr/drapeau_etape.gif" alt="" />';
							else
								number = "<img src='" + this.imgSrc2 + "blueFlag.png' width='16' height='15' alt='' />";
							blocStr += "<b>"+this.labels["lab_etape"]+" " + etapesIds[etapesIdsIndex] + this.labels["lab_dots"];
							oVMStep.stepIndex = etapesIdsIndex;
							if (roadSheet[i].addressLine == "") blocStr += roadSheet[i].city + this.labels["lab_centre"];
							else blocStr += roadSheet[i].city + ", " + roadSheet[i].addressLine;
							etapesIdsIndex++;
						}
					}
					else {
						if (roadSheet[i].landing === 0) blocStr += "<b>"+this.labels["lab_sortir"] + roadSheet[i].city + this.labels["lab_unknown2"];
						if (roadSheet[i].landing === 1) blocStr += "<b>"+this.labels["lab_entrer"] + roadSheet[i].city + this.labels["lab_unknown2"];
						if (roadSheet[i].landing === 2) blocStr += "<b>"+this.labels["lab_iti"] + roadSheet[i].city + this.labels["lab_unknown2"];
						if (roadSheet[i].landing === 3) {
							if (roadSheet[i].lDist < 450) {
								blocStr += this.labels["lab_a"] + " <b>" + roadSheet[i].city;
								isShort = true;
							}
							else blocStr += "<b>"+ this.labels["lab_traverser"] + roadSheet[i].city;
						}
						isStep = false;
						if (((roadSheet[i].landing === 0) || (roadSheet[i].landing === 3))&&(roadSheet[i].detail.length > 0)&&(!isShort)) strSortie = this.labels["lab_sortieDe"] + roadSheet[i].city;
						
					}
					if (isShort) blocStr += "</b>"+this.labels["lab_endContinue"];
					if (!isShort) blocStr += "</b>";

					if (!isStep) stepNumber++;

					oVMStep.number = number;
					oVMStep.panels = "";
					oVMStep.description = blocStr;
					oVMStep.shortDescription = oVMStep.description;
					oVMStep.partialDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].lDist,this.unit);
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
					oVMStep.mapURL = roadSheet[i].url;
					
					
				}
				if (roadSheet[i].bloc == "F")
				{
					var obj = ["coords","tDist","tTime","lDist","lTime","iso","id","message","url","detail"];
					this._configureObject(roadSheet[i], obj);
					var flag = "<img src='" + ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/flags/" + roadSheet[i].iso + ".png' alt='' />";
					oVMStep.number = flag;
					oVMStep.panels = "";
					oVMStep.description = "<b><a class='sCountryLink' href='javascript:;' onclick='window.open(\"/web/CityToCityFrontierXML?msgId="+roadSheet[i].id+"&lang="+this.lang+"&zone="+this.zone+"\",\"\",\"status=no,scrollbars=yes,width=375,height=400\")'>" + roadSheet[i].message + "</a></b>";
					oVMStep.description += "<span class='sCountryMessage'>" + roadSheet[i].message + "</span>";
					oVMStep.shortDescription = oVMStep.description;
					oVMStep.partialDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].lDist,this.unit);
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
					oVMStep.mapURL = roadSheet[i].url;
				}
				if (roadSheet[i].bloc == "POI")
				{
					var obj = ["coords","tDist","tTime","lDist","lTime","nom","addressLine","cityLine","logo","productId","id","url","detail"];
					this._configureObject(roadSheet[i], obj);
					oVMStep.number = "<img src='"+roadSheet[i].logo+"' alt='' />";
					oVMStep.panels = "";
					oVMStep.description = "<b>" + roadSheet[i].nom + " - " + roadSheet[i].addressLine + ", " + roadSheet[i].cityLine + "</b>";
					oVMStep.shortDescription = oVMStep.description;
					oVMStep.partialDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].lDist,this.unit);
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
					oVMStep.mapURL = roadSheet[i].url;
				}
				if (roadSheet[i].bloc == "CORRPOI")
				{
					var obj = ["coords","tDist","tTime","lDist","lTime","nom","logo","productId","id","poiId","addressLine","photo","countryISOCode","countryVMCode","city"];
					this._configureObject(roadSheet[i], obj);
					var poiTemp = new Object();
					
					
					var pictStyle = "";
					if (roadSheet[i].productId == 150176) {
						/* Cas spécial printemps gourmand */
						pictStyle = 'style="width:56px;height:22px;"';
					} else {
						pictStyle = 'style="width:40px;height:25px;"';
					}
					
					oVMStep.number = '<img src="' + roadSheet[i].logo + '" ' + pictStyle + '" class="cartePastillePODImg" alt="" />';
					poiTemp.bubbleLogo = '<div style="float:left;padding-right:5px;"><img src="' +  roadSheet[i].logo + '" alt="" /></div>';
					
					
					oVMStep.panels = "";
					oVMStep.bloc = "CORRPOI";
					oVMStep.name = roadSheet[i].nom;

					poiTemp.id = roadSheet[i].id;
					poiTemp.productId = roadSheet[i].productId;
					poiTemp.treatmentName = "PODSearch";
					poiTemp.city = roadSheet[i].city;
					poiTemp.countryISOCode = roadSheet[i].countryISOCode;
					poiTemp.countryVMCode = roadSheet[i].countryVMCode;
					poiTemp.photo = roadSheet[i].photo;
					poiTemp.icons = new Array();
					poiTemp.icons[0] = roadSheet[i].logo;
					poiTemp.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
					poiTemp.theme = "BRAND";
					if (this.partnerSelected=="HOTELS") {
						poiTemp.treatmentName = "HotelBooking";		
						poiTemp.theme = "HOTELS";
						if(this._checkClassified(roadSheet[i].productId) == true){
							oVMStep.number = ViaMichelin.Api.Util.Poi.drawPoiMapClassified("");
							poiTemp.bubbleLogo = '<div class="OrangeSmallDisc" style="padding-right:5px;">&nbsp;</div>';							
							
						}else {							
							oVMStep.number = ViaMichelin.Api.Util.drawPoiMapYellow("");
							poiTemp.bubbleLogo = '<div class="YellowSmallDisc" style="padding-right:5px;">&nbsp;</div>';
						}
						
					}
					if (this.partnerSelected=="TOURISM") {
						poiTemp.treatmentName = "TourismSearch";
						poiTemp.theme = "TOURISM";
						poiTemp.photoURLs = new Array();
						poiTemp.photoURLs[0] = poiTemp.photo;
						if(this._checkClassified(roadSheet[i].productId) == true){
							oVMStep.number = ViaMichelin.Api.Util.Poi.drawPoiMapClassified("");
							poiTemp.bubbleLogo = '<div class="OrangeSmallDisc" style="padding-right:5px;">&nbsp;</div>';							
							
						}else {
							oVMStep.number = ViaMichelin.Api.Util.drawPoiMap('','green');
							poiTemp.bubbleLogo = '<div class="GreenSmallDisc" style="padding-right:5px;">&nbsp;</div>';
						}
					}
					if (this.partnerSelected=="RESTOS") {
						poiTemp.treatmentName = "RestaurantSearch";
						poiTemp.theme = "RESTOS";
						if(this._checkClassified(roadSheet[i].productId) == true){
							oVMStep.number = ViaMichelin.Api.Util.Poi.drawPoiMapClassified("");
							poiTemp.bubbleLogo = '<div class="OrangeSmallDisc" style="padding-right:5px;">&nbsp;</div>';							
							
						}else {
							oVMStep.number = ViaMichelin.Api.Util.Poi.drawPoiMapRed("");
							poiTemp.bubbleLogo = '<div class="RedSmallDisc" style="padding-right:5px;">&nbsp;</div>';
						}
					}
					var _tmpHTML = "";
					_tmpHTML += "<div class='hand bleu' onclick=\"var conf = new Object();conf.itinerary  = window._VMRoadsheets["+this._VMRoadsheetsIndex+"].itinerary.cloneComponent();conf.datasheetType = 'POI_DATASHEET';conf.tab = 'description';conf.pois = window._VMRoadsheets["+this._VMRoadsheetsIndex+"]._VM_ROADSHEETPOIS;conf.theme = '"+poiTemp.theme+"';conf.corridor = true;conf.poi ={id:'"+poiTemp.id+"',productId:"+poiTemp.productId+",treatmentName:'"+poiTemp.treatmentName+"',theme:'"+poiTemp.theme+"',coords:{lon:"+poiTemp.coords.lon+",lat:"+poiTemp.coords.lat+"}};JSELaunch('ViaMichelin.B2C.Web.Datasheet', conf, new JSEWire('onInit', window._VMRoadsheets["+this._VMRoadsheetsIndex+"]._datasheetWiring, window._VMRoadsheets["+this._VMRoadsheetsIndex+"]));\" onmouseover='this.style.color=\"#ffaa39\"' onmouseout='this.style.color=\"#0084FF\"'><div style='float:left;'>"+oVMStep.number+"</div>&nbsp;<b>" + roadSheet[i].nom + "</b></div>";
					_tmpHTML += "<div id='VMRoadSheetDetail_"+roadSheet[i].poiId+"' style='display:none;'>" + roadSheet[i].addressLine + "</div>";
					oVMStep.description = _tmpHTML;
					oVMStep.shortDescription = oVMStep.description;
					poiTemp.name = roadSheet[i].nom;
					poiTemp.displayAddress = poiTemp.address = roadSheet[i].addressLine.toLowerCase();
					
					oVMStep.poi = poiTemp;
					if ((typeof(window._VMRoadsheets[this._VMRoadsheetsIndex]._VM_ROADSHEETPOIS) == "undefined")||(window._VMRoadsheets[this._VMRoadsheetsIndex]._VM_ROADSHEETPOIS == null)) _VMRoadsheets[this._VMRoadsheetsIndex]._VM_ROADSHEETPOIS = new Array();
					window._VMRoadsheets[this._VMRoadsheetsIndex]._VM_ROADSHEETPOIS.push(poiTemp);
					oVMStep.partialDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].lDist,this.unit);
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
				}
				if (roadSheet[i].bloc == "CP")
				{
					var obj = ["tDist","tTime","url","detail"];
					this._configureObject(roadSheet[i], obj);
					var dirLab = this.labels["lab_dirCP"];
					if ((roadSheet[i+1])&&(roadSheet[i+1][0]=="V")) dirLab += " " + this.labels["lab_dirVers"] + " <b>" + this._getWayList(roadSheet[i+1][10]) + "</b>";

					oVMStep.number = stepNumber++;
					oVMStep.panels = "";
					oVMStep.picto = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/sortie.png' alt='' />";
					oVMStep.description = dirLab;
					oVMStep.shortDescription = oVMStep.description;
					oVMStep.partialDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].lDist,this.unit);
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.mapURL = roadSheet[i].url;
				}
				if (roadSheet[i].bloc == "S")
				{
					var obj = ["coords","tDist","tTime","lDist","lTime","type","libelle","dir","style","pays","url","detail"];
					this._configureObject(roadSheet[i], obj);
					var dirLab = "";//this.labels["lab_dirLab"] + this._buildPanneaux("S", roadSheet[i].libelle,roadSheet[i].style,roadSheet[i].pays,roadSheet[i].url);
					
					if (roadSheet[i].libelle instanceof Array && roadSheet[i].libelle.length == 0){
						dirLab = this.labels["lab_dirCP"];
					} else {
						dirLab = this.labels["lab_dirLab"] + this._buildPanneaux("S", roadSheet[i].libelle,roadSheet[i].style,roadSheet[i].pays,roadSheet[i].url);
					}
					
					oVMStep.number = stepNumber++;
					oVMStep.panels = "";
					oVMStep.picto = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/sortie.png' alt='' />";
					oVMStep.description = dirLab;
					oVMStep.shortDescription = oVMStep.description;
					oVMStep.partialDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].lDist,this.unit);
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
					oVMStep.mapURL = roadSheet[i].url;
				}
				if (roadSheet[i].bloc == "c")
				{
					var obj = ["coords","tDist","tTime","lDist","lTime","city","cityLine","addressLine","isNeighbor","type","reflex","landing","url","detail"];
					this._configureObject(roadSheet[i], obj);
					var picto = "";

					if (roadSheet[i].type == 1) {
						picto = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/pont.png' alt='' />";
						dirLab = "<b> "+roadSheet[i].city + "</b>";
						oVMStep.className = 'pont';
					} else if (roadSheet[i].type == 2) {
						picto = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/tunnel.png' alt='' />";
						dirLab = "<b> "+roadSheet[i].city + "</b>";
						oVMStep.className = 'tunnel';
					} else {
						if (roadSheet[i].isNeighbor) dirLab = this.labels["lab_proxPassage"]+" <b>" + roadSheet[i].city + "</b>";
						else dirLab = this.labels["lab_traverserDe"]+" <b>" + roadSheet[i].city + "</b>";
						oVMStep.className = 'proximite';
					}

					oVMStep.number = stepNumber++;
					oVMStep.panels = "";
					oVMStep.picto = picto;
					oVMStep.description = dirLab;
					oVMStep.shortDescription = oVMStep.description;
					oVMStep.partialDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].lDist,this.unit);
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
					oVMStep.mapURL = roadSheet[i].url;
				}
				if (roadSheet[i].bloc == "M")
				{
					var obj = ["coords","tDist","tTime","message","type","url","detail"];
					this._configureObject(roadSheet[i], obj);
					var picto = "";
					if ((roadSheet[i].type != "")&&(roadSheet[i].type != 0)) picto = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/msg"+roadSheet[i].type+".png' alt='' />";

					oVMStep.number = "";
					oVMStep.panels = "";
					oVMStep.picto = picto;
					oVMStep.description = (roadSheet[i].message == "lab_security") ? this.labels["lab_security"] : roadSheet[i].message;
					oVMStep.shortDescription = oVMStep.description;
					oVMStep.partialDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].lDist,this.unit);
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
					oVMStep.mapURL = roadSheet[i].url;
					
					if (roadSheet[i].type == "13"){
						oVMStep.className = 'radar';
						this.alertes.nbAlertesSignalisations++;
						var item = new Object();
						item.picto = oVMStep.picto;
						item.description = oVMStep.description;
						item.totalDistance = oVMStep.totalDistance;
						this.alertes.liste.push(item);
					}
				}
				if (roadSheet[i].bloc == "vir")
				{
					//Virage à gauche ISOLE_GAUCHE = 0;
					//Virage à droite ISOLE_DROITE = 1;
					//Zone de virage gauche ZONE_GAUCHE = 2;
					//Zone de virage gauche ZONE_DROITE = 3;
					var obj = ["coords","tDist","tTime","longueur","type"];
					this._configureObject(roadSheet[i], obj);
					var picto = "";
					if (typeof(roadSheet[i].type) != "undefined" && roadSheet[i].type != 4){
						 picto = '<img class="itifdr18" src="'+ ViaMichelin.Api.Constants.System.ApiImgPath + 'all/data/itifdr/vir'+roadSheet[i].type+'.png\"  alt="" />';
					}
					oVMStep.number = "";
					oVMStep.panels = "";
					oVMStep.picto = picto;
					if(roadSheet[i].type == 0){
						oVMStep.description = this.labels['lab_virage_gauche'];
					}
					else if(roadSheet[i].type == 1){
						oVMStep.description =  this.labels['lab_virage_droite'];
					}
					else if(roadSheet[i].type == 2){
						if(roadSheet[i].longueur > 150)
							oVMStep.description = this.labels['lab_zone_virage_large_g'].replaceAll('$L',ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].longueur,this.unit));
						else
							oVMStep.description =  this.labels['lab_zone_virage_small_g'];
					}
					else if(roadSheet[i].type == 3){
						if(roadSheet[i].longueur > 150)
							oVMStep.description = this.labels['lab_zone_virage_large_d'].replaceAll('$L',ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].longueur,this.unit));
						else
							oVMStep.description =  this.labels['lab_zone_virage_small_d'];
					}
					oVMStep.shortDescription = oVMStep.description;
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
					oVMStep.mapURL = "";
					oVMStep.className="virage";
					this.alertes.nbAlertesSignalisations++;
					var item = new Object();
					item.picto = oVMStep.picto;
					item.description = oVMStep.description;
					item.totalDistance = oVMStep.totalDistance;
					this.alertes.liste.push(item);
					
				}
				if (roadSheet[i].bloc == "lim")
				{
					var obj = ["coords","tDist","tTime","longueur","lim"];
					this._configureObject(roadSheet[i], obj);
					if(roadSheet[i].lim%5 == 0)
					{
						oVMStep.number = "";
						oVMStep.panels = "";
						oVMStep.picto = '<img class="itifdr19" src="'+ ViaMichelin.Api.Constants.System.ApiImgPath + 'all/data/itifdr/vitesse'+roadSheet[i].lim+'.png\"  alt="" />';
						if(roadSheet[i].longueur > 150)
							oVMStep.description = this.labels['lab_vitesse_large'].replaceAll('$V',roadSheet[i].lim).replaceAll('$L',ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].longueur,this.unit));
						else
							oVMStep.description = this.labels['lab_vitesse_small'].replaceAll('$V',roadSheet[i].lim);
						oVMStep.shortDescription = oVMStep.description;
						oVMStep.partialDistance = "";
						oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
						oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
						oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
						oVMStep.mapURL = "";
						oVMStep.className="limitation";
						
						this.alertes.nbAlertesSignalisations++;
						var item = new Object();
						item.picto = oVMStep.picto;
						item.description = oVMStep.description;
						item.totalDistance = oVMStep.totalDistance;
						this.alertes.liste.push(item);
					}
				}
				if (roadSheet[i].bloc == "dec")
				{
					var obj = ["coords","tDist","tTime","longueur","pente"];
					this._configureObject(roadSheet[i], obj);
					oVMStep.number = "";
					oVMStep.panels = "";
					oVMStep.picto = '<img class="itifdr18" src="'+ ViaMichelin.Api.Constants.System.ApiImgPath + 'all/data/itifdr/pente.png\" alt="" />';
					if(roadSheet[i].longueur > 150)
						oVMStep.description = this.labels['lab_pente_large'].replaceAll('$L',ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].longueur,this.unit));
					else
						oVMStep.description = this.labels['lab_pente_small'];
					oVMStep.shortDescription = oVMStep.description;
					oVMStep.partialDistance = "";
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
					oVMStep.mapURL = "";
					oVMStep.className="pente";
					
					this.alertes.nbAlertesSignalisations++;
					var item = new Object();
					item.picto = oVMStep.picto;
					item.description = oVMStep.description;
					item.totalDistance = oVMStep.totalDistance;
					this.alertes.liste.push(item);
				}
				if (roadSheet[i].bloc == "pan")
				{
					var obj = ["coords","tDist","tTime","lDist","lTime","panneau","style","pays","infoRoute"];
					this._configureObject(roadSheet[i], obj);

					var message = this.labels["lab_suivreDir"] + this._buildPanneaux("pan", roadSheet[i].panneau,roadSheet[i].style,roadSheet[i].pays, roadSheet[i].infoRoute);
					oVMStep.number = stepNumber++;
					oVMStep.panels = "";
					oVMStep.picto = "";
					oVMStep.description = message;
					oVMStep.shortDescription = oVMStep.description;
					oVMStep.partialDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].lDist,this.unit);
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
				}
				if (roadSheet[i].bloc == "P")
				{
					var obj = ["coords","tDist","tTime","lDist","lTime","nom","monnaie","auto","caravan","pl2","pl3","pl4","pl5","moto","url","detail"];
					this._configureObject(roadSheet[i], obj);

					var picto = "";
					if (roadSheet[i].monnaie == "") picto = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/peage.png' alt=''/>";
					else picto = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/peageP.png' alt='' />";
					var message = "";
					if (roadSheet[i].monnaie != "") message = roadSheet[i].nom + this.labels["lab_peage"] + this._formatNumber(roadSheet[i][this.tollVehicule]/100) + " " + roadSheet[i].monnaie;
					else message = roadSheet[i].nom + this.labels["lab_ticket"];

					oVMStep.number = stepNumber++;
					oVMStep.panels = "";
					oVMStep.picto = picto;
					oVMStep.description = message;
					oVMStep.shortDescription = oVMStep.description;
					oVMStep.partialDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].lDist,this.unit);
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
					oVMStep.mapURL = roadSheet[i].url;
				}
				if (roadSheet[i].bloc == "D")
				{
					var obj = ["coords","tDist","tTime","lDist","lTime","libelle","side","type","style","pays","url","detail"];
					this._configureObject(roadSheet[i], obj);

					var message = this.labels["lab_suivreDir"] + this._buildStyledDirections(roadSheet[i].libelle,roadSheet[i].style,roadSheet[i].pays) + "";

					oVMStep.number = stepNumber++;
					oVMStep.panels = "";
					oVMStep.picto = "";
					oVMStep.description = message;
					oVMStep.shortDescription = oVMStep.description;
					oVMStep.partialDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].lDist,this.unit);
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
					oVMStep.mapURL = roadSheet[i].url;
				}
				if (roadSheet[i].bloc == "R")
				{
					var obj = ["coords","tDist","tTime","lDist","lTime","nbVoie","name","pays","url","detail"];
					this._configureObject(roadSheet[i], obj);

					var dirLab = "";
					if (roadSheet[i].nameRondPoint != "") dirLab = this.labels["lab_rond1"] + " " + roadSheet[i].nameRondPoint+", " +this.labels["lab_rond2"] +" " + this._computeRoundWording(roadSheet[i].nbVoie);
					else dirLab = this.labels["lab_rondFull"] + roadSheet[i].nbVoie + this._computeRoundWording(roadSheet[i].nbVoie);
					var strPicto = "";
					if ((roadSheet[i].pays == "GBR")||(roadSheet[i].pays == "IRL")) strPicto = "GBR";

					oVMStep.number = stepNumber++;
					oVMStep.panels = "";
					oVMStep.picto = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/rondPoint"+strPicto+".png'  alt='' />";
					oVMStep.description = dirLab;
					oVMStep.shortDescription = oVMStep.description;
					oVMStep.partialDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].lDist,this.unit);
					oVMStep.totalTime = ViaMichelin.Api.Util.Other.makeHour(roadSheet[i].tTime);
					oVMStep.totalDistance = ViaMichelin.Api.Util.Other.makeDist(roadSheet[i].tDist,this.unit);
					oVMStep.coords = new ViaMichelin.Api.Model.GeoCoordinates(roadSheet[i].coords.lon, roadSheet[i].coords.lat);
					oVMStep.mapURL = roadSheet[i].url;
				}
				
				
				if ((roadSheet[i].detail)&&(roadSheet[i].detail.length > 0)) oVMStep.details = this._transform(roadSheet[i].detail, strSortie );
				result.push(oVMStep);
			}
		}
		if (str) {
			var sVMStep = new ViaMichelin.Api.Model.Itinerary.ItineraryStep();
			sVMStep.number = "";
			sVMStep.panels = "";
			sVMStep.picto = "";
			sVMStep.description = str;
			sVMStep.shortDescription = str;
			sVMStep.partialDistance = "";
			sVMStep.totalTime = "";
			sVMStep.totalDistance = "";
			sVMStep.coords = "";
			sVMStep.mapURL = "";
			result.push(sVMStep);
		}
		
		return result;
	},
	_configureObject : function(json, obj)
	{
		for (var i=0; i < obj.length; i++) {
			if ((!json[obj[i]])||(obj[i] == "detail")) json[obj[i]] = json[i];
		}
	},
	_createExpandWarningElement : function () {
		var expandLayer = '<div class="sPODBubble">' + this.sousStep.description + '</div>';
		this.setExpandLayer(expandLayer);
	},
	_createExpand : function() {
		var oDiv = document.createElement("div");
		oDiv.innerHTML =	'<div style="width:300px;height:140px;background-color:#FFF;">' +
								'<div style="width:300px;height:40px;">' + this.poi.bubbleLogo +
									'<div style="height:20px;font-size:14px;font-weight:bold;" class="hand txtLink">' + this.poi.name + '</div>' +
								'</div>' +
								'<div style="width:200px;height:100px;float:left;">' +
									'<div style="width:200px;height:50px;font-size:12px;font-weight:100;padding-top:10px;">' + this.poi.displayAddress + '</div>' +
									'<div><span class="hand poiIti">' + _application.trads["DEPUIS"] + '</span> | <span class="hand poiIti">' + _application.trads["VERS"] + '</span> | <span class="hand poiIti">' + _application.trads["VIA"] + '</span> ' + _application.trads["CETTE_ADRESSE"] + '</div>' +
									'<div style="width:200px;height:40px;"><button class="btnButton btnMoreInfo">' + _application.trads["MORE_INFO"] + '</button></div>' +
								'</div>' +
								(this.poi.photo ?
								('<div style="overflow:hidden;width:95px;height:95px;float:right;padding-top:15px;">' +
									'<img id="poiPic" width="95" height="95" src="' + this.poi.photo + '"  alt="" />' +
								'</div>') : "") +
							'</div>';
		
		var o3 = oDiv.getElementsByTagName("div")[3];
		o3.expando = this.expando;
		o3.poi = this.poi;
		o3.onclick = (this.poi.isPoiBrandPlacement()) ? this.expando._clickOnBrand : this.expando._clickOnPoi;
		
		var o31 = oDiv.getElementsByTagName("button")[0];
		o31.expando = this.expando;
		o31.poi = this.poi;
		o31.onclick = (this.poi.isPoiBrandPlacement()) ? this.expando._clickOnBrand : this.expando._clickOnPoi;
		
		var o6 = oDiv.getElementsByTagName("div")[6];
		var o6s0 = o6.getElementsByTagName("span")[0];
		o6s0.poi = this.poi;
		o6s0.expando = this.expando;
		o6s0.onclick = this.expando._clickOnFromIti;
		
		var o6s1 = o6.getElementsByTagName("span")[1];
		o6s1.poi = this.poi;
		o6s1.expando = this.expando;
		o6s1.onclick = this.expando._clickOnToIti;
		
		var o6s2 = o6.getElementsByTagName("span")[2];
		o6s2.expando = this.expando;
		o6s2.poi = this.poi;
		o6s2.onclick = this.expando._clickOnViaIti;
		
		var imgs = oDiv.getElementsByTagName("img");
		for (var i=0; i<imgs.length; i++){
			if (imgs[i].id == "poiPic") {
				imgs[i].expando = this.expando;
				imgs[i].poi = this.poi;
				imgs[i].onclick = (this.poi.isPoiBrandPlacement() ? this.expando._clickOnBrand : this.expando._clickOnPoi);
			}
		}
		
		this.setExpandLayer(oDiv);
	},
	_createDivNode : function(className, inner){
		var node = document.createElement("DIV");
		if (className && className != ""){
			node.className = className;
		}
		if (inner && inner != ""){
			node.innerHTML = inner;
		}
		return node;
	},
	_createImgNode : function(className, src){
		var node = document.createElement("img");
		if (className && className != ""){
			node.className = className;
		}
		if (src && src != ""){
			node.src = src;
		}
		return node;
	},
	_getDetailHTML : function(steps)
	{
		var strHTML = "";
		for (var i=0; i < steps.length; i++)
		{
			strHTML += '<tr';
			if(typeof(steps[i].className) != "undefined"){
				strHTML += ' class="'+steps[i].className+'"'; 
			}
			strHTML += '>'
			+ ( (steps[i].partialDistance != "") ? (
				'<td class="fdr_underStep">' + steps[i].picto + " " + steps[i].description + '</td>'
				+ '<td class="fdr_lightGrey">'+((steps[i].partialDistance != "") ? "("+steps[i].partialDistance+")" : "")+'</td>'
				+ '<td></td>'
				+ '<td></td>')
			: (
				'<td class="fdr_underStep">' + steps[i].picto + " " + steps[i].description +'</td>'
				+ '<td></td>'
				+ '<td>'+steps[i].totalDistance+'</td>'
				+ '<td>'+steps[i].totalTime+'</td>'))
			+ '</tr>';
		}
		return strHTML;
	},
	_getMapBlock:function(url) {
		if (url == "") return "";
		var text = '<div class="mapBlock">';
		text += '<span class="txtLink" onclick="this.parentNode.getElementsByTagName(\'img\')[0].style.display = \'block\';this.parentNode.getElementsByTagName(\'img\')[0].src = \''+url+'\';this.style.display = \'none\';resizeBackGround(document.body);">'+this.labels['lab_map']+'</span>';
		text += '<img src="'+ ViaMichelin.Api.Constants.System.ApiImgPath + 'all/s.gif" onclick="this.parentNode.getElementsByTagName(\'span\')[0].style.display = \'inline\';this.style.display = \'none\';resizeBackGround(document.body);" style="display:none;width:250px;height:200px;" />';
		text += '</div>';
		return text;
	},
	_getMapBlockElement:function(url) {
		var divElement = this._createDivNode('mapBlock');
		var spanElement = document.createElement('SPAN');
		var imgElement = this._createImgNode('',url);
		spanElement.innerHTML = this.labels['lab_map'];
		spanElement.className = 'txtLink';
		spanElement.onclick = function(){
			this.style.display = 'none';
		};
		
		imgElement.style.display = 'none';
		imgElement.span = spanElement;
		imgElement.onclick = function(){
			this.span.style.display = 'inl'+'ine';
			this.style.display = 'none';
		};
		divElement.appendChild(imgElement);
		divElement.appendChild(spanElement);
		
		return divElement;
	},
	_buildPanneaux : function(type, panneau, style, pays, infoRoute){
		var entete = "";
		var str = "";
		var panneau2 = new Array();
		
		for (var i = 0; i < panneau.length; i++){
			var itemPanneau = panneau[i];
			var obj = ["libelle","connexiontype","mentionType","routeType","picto","direction","primarySequence","secondarySequence"];
			this._configureObject(itemPanneau, obj);
			var found = false;
			if(typeof(infoRoute) != "undefined" && infoRoute != ""){
				for (var j = 0; j < infoRoute.length; j++){
					var itemInfo = infoRoute[j];
					var obj2 = ["libelle","typeHierarchique","style"];
					this._configureObject(itemInfo, obj2);
					if(itemPanneau.libelle == itemInfo.libelle){
						found = true;
						var span = '<span class="panBlock pan'+itemInfo.style+'">'+itemPanneau.libelle+'</span>';
						entete += span;
					}
				}
				
			}
			if (!found){
				panneau2.push(itemPanneau);
			}
		}
		if (entete != ""){
			entete = '<div style="width:206px;text-align:center;" class="roadNumber">'+entete+'</div>';
		}
		
		for (var i = 0; i < panneau2.length; i++){
			var itemPanneau = panneau2[i];
			//Picto
			if (itemPanneau.mentionType == 8){
				str += '<img class="itifdr14" src="'+ ViaMichelin.Api.Constants.System.ApiImgPath + 'all/data/itifdr/picto_' + itemPanneau.picto + '.png"  alt="" />';
				if (i+1<panneau2.length){
					var itemPanneauNext = panneau2[i+1];
					if (itemPanneau.primarySequence != itemPanneauNext.primarySequence){
						str += '<br/>';
					}
					else 
						str += ' ';
				}
			}
			//Sortie
			else if (type!= "pan" && (itemPanneau.mentionType == 1 || itemPanneau.mentionType == 2)){
				var sortie = this.labels['lab_sortie_nom'] + itemPanneau.libelle + '<BR/>';
				if ((pays == "FRA")||(pays == "ITA"))
					str += sortie.toUpperCase();
				else
					str += sortie;
			}
			//Ligne normal
			else if (itemPanneau.libelle != ""){
				var ligneNormal = '';
				ligneNormal += itemPanneau.libelle;
				if (i+1<panneau2.length){
					var itemPanneauNext = panneau2[i+1];
					if (itemPanneau.primarySequence == itemPanneauNext.primarySequence){
						ligneNormal  += ' - ';
					}
					else{
						ligneNormal  += '<br/>';
					}
				}
				if (pays == "FRA" || pays == "ITA")
					str += ligneNormal.toUpperCase();
				else
					str += ligneNormal;
			}
		}
		var classContainer = 'panBlock pan' + style;
		return entete + '<div class="'+classContainer+'">'+str+'</div>';
	},
	_formatNumber : function(num)
	{
		num = num.toString();
		if (num.indexOf(".") != -1) 
		{
			var entier = num.substring(0, num.indexOf("."));
			var decimal = num.substr(num.indexOf(".")+1);
			if (decimal.length == 1) decimal = decimal + "" + "0";
			if (decimal.length > 2) decimal = Math.round(parseInt(decimal) / Math.pow(10,decimal.length-2));
			return entier + "." + decimal;
		} else num = num + ".00";
		return num;
	},
	_computeRoundWording : function(nSortie)
	{
		if (nSortie == 1) return this.labels["lab_one"];
		if (nSortie == 2) return this.labels["lab_two"];
		if (nSortie == 3) return this.labels["lab_three"];
		if (nSortie > 3) return this.labels["lab_more"].replace("$N", nSortie);
	},
	/**
	 * @param {Array} voies
	 * @return {String}
	 */
	_getWayList : function(voies) {
		var w = 0;
		var value = "";
		while (w < voies.length){
			if (voies[w][0] != ""){
				if (w > 0){
					value += " / ";
				}
				value += voies[w][0];
			}
			w++;
		}
		return value;
	},
	/**
	 * @param {Object} wayBlock
	 * @param {Boolean} firstWay
	 * @param {String} lastWay
	 * @param {Boolean} dontShowPanels
	 * @return {String}
	 */
	_wayToHTML : function(wayBlock,firstWay,lastWay,dontShowPanels) {
		var lower = false;
		var imgIti = this.imgSrc;
		var text = "";
		if (wayBlock.inCity != "") {
			if (wayBlock.inProxy) text += this.labels["lab_prox"] + " <b>" + wayBlock.inCity + "</b>"+this.labels["lab_unknown"]+", ";
			else text += this.labels["lab_a"] + " <b>" + wayBlock.inCity + "</b>, ";
		}
		if (wayBlock.inAngle == 0) {
			if (this._getWayList(wayBlock[10]) == "") {
				text += ((!lower) ? this.labels["lab_continue_droit"] : this.labels["lab_continue_droit"].toLowerCase());
			} else if (!firstWay) {
				if (lastWay == this._getWayList(wayBlock[10])) {
					text += ((!lower) ? this.labels["lab_continue"] : this.labels["lab_continue"].toLowerCase()) +" " + this._mkWay(wayBlock," "+this.labels["lab_sur"]+" ")+ "<b>" + this._getWayList(wayBlock[10]) + "</b>";
				} else {
					text += ((!lower) ? ((wayBlock.isWithDirection) ? this.labels["lab_prendre"] : this.labels["lab_rond_point_continue"]) : ((wayBlock.isWithDirection) ? this.labels["lab_prendre"].toLowerCase() : this.labels["lab_rond_point_continue"].toLowerCase())) + this._mkWay(wayBlock,"")+ "<b>" + this._getWayList(wayBlock[10]) + "</b>";
				}
			} else {
				text += ((!lower) ? ((wayBlock.isWithDirection) ? this.labels["lab_prendre"] : this.labels["lab_rond_point_continue"]) : ((wayBlock.isWithDirection) ? this.labels["lab_prendre"].toLowerCase() : this.labels["lab_rond_point_continue"].toLowerCase())) + this._mkWay(wayBlock,"")+ "<b>" + this._getWayList(wayBlock[10]) + "</b>";
			}
		}
		if (wayBlock.inAngle == -18 || wayBlock.inAngle == 18) {
			text += ((!lower) ?this.labels["lab_demitour"]:this.labels["lab_demitour"].toLowerCase())+ this._mkWay(wayBlock,this.labels["lab_dots"]) + " <b>" + this._getWayList(wayBlock[10]) + "</b>";
		}
		if (wayBlock.inAngle > 0 && wayBlock.inAngle <= 17) {
			if (this._getWayList(wayBlock[10]) == "") text += ((!lower) ?this.labels["lab_turnRight"]:this.labels["lab_turnRight"].toLowerCase());
			else text += ((!lower) ?this.labels["lab_takeRight"] : this.labels["lab_takeRight"].toLowerCase())+ this._mkWay(wayBlock,this.labels["lab_dots"]) + " <b>" + this._getWayList(wayBlock[10]) + "</b>";
			wayBlock.picto = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/right.png' alt='' /><br/>";
		}
		if (wayBlock.inAngle >= -17 && wayBlock.inAngle < 0) {
			if (this._getWayList(wayBlock[10]) == "") text += ((!lower) ?this.labels["lab_turnLeft"] : this.labels["lab_turnLeft"].toLowerCase());
			else text += ((!lower) ?this.labels["lab_takeLeft"]: this.labels["lab_takeLeft"].toLowerCase())+ this._mkWay(wayBlock,this.labels["lab_dots"]) + " <b>" + this._getWayList(wayBlock[10]) + "</b>";
			wayBlock.picto = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/left.png' alt='' /><br/>";
		}
		if (wayBlock.inRondPoint != -1) {
			text = ( (wayBlock.nameRondPoint!="") ? this.labels["lab_rond1"]+" " + wayBlock.nameRondPoint+", " +this.labels["lab_rond2"] : this.labels["lab_rondFull"] ) + " " +this._computeRoundWording(wayBlock.inRondPoint) +" "+ this._mkWay(wayBlock,this.labels["lab_rond_point_continue"]+" ") + "<b>" + this._getWayList(wayBlock[10]) + "</b>";

			if (wayBlock.inCity != "") {
				if (wayBlock.inProxy) text = this.labels["lab_prox"]+" <b>" + wayBlock.inCity + "</b>"+", "+( (wayBlock.nameRondPoint!="") ? this.labels["lab_rond1"]+" " + wayBlock.nameRondPoint+", " +this.labels["lab_rond2"] : this.labels["lab_rondFull"] ) +" " + this._computeRoundWording(wayBlock.inRondPoint) +" "+ this._mkWay(wayBlock,this.labels["lab_rond_point_continue"]+" ") + "<b>" + this._getWayList(wayBlock[10]) + "</b>";
				else text = this.labels["lab_a"] +" <b>" + wayBlock.inCity + "</b>, "+( (wayBlock.nameRondPoint!="") ? this.labels["lab_rond1"]+" " + wayBlock.nameRondPoint+", " +this.labels["lab_rond2"] : this.labels["lab_rondFull"] ) +" " + this._computeRoundWording(wayBlock.inRondPoint) +" "+ this._mkWay(wayBlock,this.labels["lab_rond_point_continue"]+" ") + "<b>" + this._getWayList(wayBlock[10]) + "</b>";
			}
			strPicto = "";
			if ((wayBlock.pays == "GBR")||(wayBlock.pays == "IRL")) strPicto = "GBR";
			wayBlock.picto = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/rondPoint"+strPicto+".png'  alt='' /><br/>";
		}
		if (wayBlock.type == 4) wayBlock.picto = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/fdr_pieton.png'  alt=''/><br/>";

		if ((wayBlock.inDirLib != "")&&(!dontShowPanels)) {
			 text += "<span class=noMap> "+this.labels["lab_direction"]+" </span>";
		}
	
		if ((wayBlock.inDirLib != "")&&(!dontShowPanels)) {
			text += "<div class=dirPan>" + this._buildPanneaux("V", wayBlock.inDirLib,wayBlock.inStyle,wayBlock.pays,(wayBlock.coords != "" ? wayBlock.voies : "")) + "</div>";
		}
		return text;
	},
	_buildStyledDirections : function(blocStr,style,pays)
	{
		while (blocStr.indexOf(",") != -1) blocStr = blocStr.substring(0,blocStr.indexOf(",")) + "<br/>" + blocStr.substr(blocStr.indexOf(",")+1);
		if ((pays == "FRA")||(pays == "ITA")) blocStr = blocStr.toUpperCase();
		var classContainer = "pan" + style;
		return "<div class='"+classContainer+"' style='padding:5px;width:200px;text-align:center;margin:5px;margin-left:0px;'>"+blocStr+"</div>";
	},
	_mkWay : function(wayBlock,str)
	{
		return ((this._getWayList(wayBlock[10])!="")?str:"");
	},
	_computePanneaux : function(wayBlock,imgIti)
	{
		var strPanneaux = "";
		var lastType = "";
		var imgIti = this.imgSrc;
		var p = 0;
		while (p < wayBlock[10].length)
		{
			if ((wayBlock[10][p]!="")&&(wayBlock[10][p][1] != lastType)&&(wayBlock[10][p][0].length<7)) {
				strPanneaux += '<div class="pan' + wayBlock[10][p][2] + '" style="text-align:center">' + wayBlock[10][p][0] + '</div>';
				lastType = wayBlock[10][p][1];
			}
			p++;
		}
		if		(wayBlock.type == 6) strPanneaux = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/highway.png' alt='' />" + strPanneaux;
		else if (wayBlock.type == 5) strPanneaux = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/express.png' alt='' />" + strPanneaux;
		else if (wayBlock.type == 3) strPanneaux = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/liaisF.png' alt='' />" + strPanneaux;
		else if (wayBlock.type == 1) strPanneaux = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/liaisM.png' alt='' />" + strPanneaux;
		else if (wayBlock.type == 2) strPanneaux = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/liaisM.png' alt='' />" + strPanneaux;
		else if (wayBlock.type == 4) strPanneaux = "<img class='itifdr18' src='"+ ViaMichelin.Api.Constants.System.ApiImgPath + "all/data/itifdr/fdr_pieton.png' alt='' />" + strPanneaux;
		return strPanneaux;
	},
	_checkClassified : function(productId){
		if(productId == "125197" || productId == "125196" || productId == "125198"
		|| productId == "125201" || productId == "125199"){
			return true;
		}
		return false;
	},
	clone : function(){
		var cloneComponent = new ViaMichelin.Api.Model.Itinerary.RoadSheetV1();
		for (var item in this) {
			if (item == "steps") {
				cloneComponent["steps"] = [];
				for(var i=0;i<this.steps.length;i++){
					cloneComponent["steps"].push(this.steps[i]);
				}
			} else {
				cloneComponent[item] = this[item];
			}
		}
		
		// ajout de roadsheet au tableau global.
		if (window._VMRoadsheets != null) {
			window._VMRoadsheets.push(cloneComponent);
			cloneComponent._VMRoadsheetsIndex = window._VMRoadsheets.length - 1;
		}
		
		return cloneComponent;
	},
	toString : function(){
		return "[ViaMichelin.Api.Model.Itinerary.RoadSheetV1]";	
	}
};